#ifndef OPTION_H
#define OPTION_H

#include <stdlib.h>
#include <sys/time.h>
#include <stdarg.h>

#include <string>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <map>

namespace OptionLibrary
{
	using std::string;
	using std::vector;
	using std::map;

	// إѴؿ

	// stringchar*ؤѴ
	void c_copy( const string& s, char* c, size_t size );

	// ʸ󤫤ͤؤѴ
	bool toInt( const string& s, int& value );
	bool toUInt( const string& s, unsigned int& value );
	bool toChar( const string& s, char& value );
	bool toUChar( const string& s, unsigned char& value );
	bool toDouble( const string& s, double& value );

	// ǥХå٥
	enum DebugLevel {
		DEBUG_LEVEL_SILENCE = 0,
		DEBUG_LEVEL_OMIT = 1,
		DEBUG_LEVEL_NORMAL = 2,
		DEBUG_LEVEL_VERBOSE = 3,
		DEBUG_LEVEL_ALL = 4,
	};

	// ץΥǥեͤ빽¤
	struct DefaultOptionValue {
		string ident;		// ̻
		string key;			// ץ󥭡(ʣ','Ƕڤ)
		string value;		// ץ
		string description;	// ץξܺ
		bool onOff;			// ONOFFΥå
		bool hasValue;		// ͤĥץ󤫡
	};

	// ץϤϿ뤿Υ饹
	class Args {

		// ץͤʤɤϿ뤿ι¤
		struct OptionValue
		{
			string ident;
			string value;
			bool onOff;
			bool hasValue;

			// 󥹥ȥ饯
			OptionValue()
			 : ident( "" ), value( "" ), onOff( false ), hasValue( false ) {}
			OptionValue( const DefaultOptionValue o )
			 : ident( o.ident ), value( o.value ), onOff( o.onOff ), hasValue( o.hasValue ) {}
			// ͤϿ
			void set() { onOff = true; }
			void set( const string& s )
			{
				onOff = true;
				if ( hasValue ) value = s;
			}
		};

		typedef map<string,OptionValue> MapOpt;

		map<string,string> optKey;	// ץ󥭡ϿMap
		MapOpt option;				// ץϿMap
		vector<string> args;		// Ͽvector

	public:

		// 󥹥ȥ饯
		Args( DefaultOptionValue optionArray[], size_t optionSize );

		// ϤϿ
		bool set( int argc, char* argv[] );

		// ץͤ
		bool getOpt( const string& ident, string& value ) const;
		bool getOpt( const string& ident, bool& value ) const;
		bool isSet( const string& ident ) const;

		// 
		vector<string> getArgs() const { return( args ); }
		string getArg( unsigned int i ) const { return( ( i < argSize() ) ? args[i] : "" ); }

		// ץΥ伱̻ҤΥꥹȤ֤
		vector<string> keys() const;
		vector<string> idents() const;

		// θĿ֤
		unsigned int argSize() const { return( args.size() ); }

		// ǥХåѽ
		void debugPrint( string debugIdent, int level, char* fmt, ... );
	};

}

#endif
